<?php


namespace OrganizationsManagement\Api\OrganizationProduct\Controllers;

use Exception;
use OrganizationsManagement\Api\OrganizationProduct\Services\OrganizationProduct as OrganizationProductService;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class OrganizationProduct
{
    /**
     * @var OrganizationProductService
     */
    private $organizationProductService;

    public function __construct(OrganizationProductService $organizationProductService)
    {
        $this->organizationProductService = $organizationProductService;
    }

    /**
     * @param Request $request
     * @param Response $response
     */
    public function findOrganizationProduct(Request $request, Response $response)
    {
        try {
            $productId = $request->getParameter('PRODUCT_ID');
            $filterDtValidade = isset($request->getParameters()['FILTER_DTVALIDADE']) ? $request->getParameter('FILTER_DTVALIDADE') : 'S';
            $data = $this->organizationProductService->findOrganizationProduct($productId, $filterDtValidade);
            $response->addDataSet(new DataSet('data', $data));
        } catch (Exception $ex) {
            $response->addMessage(new Message($ex->getMessage()));
            $response->setError(new Error($ex->getMessage(), $ex->getCode()));
        }
    }
}
