<?php

namespace OrganizationsManagement\Api\OrganizationProduct\Repositories;

use Doctrine\DBAL\Exception;
use OrganizationsManagement\Repository\RepositoryBase;

class OrganizationProduct extends RepositoryBase
{
    const ENTITY_NAME = '\Teknisa\Model\Teknisa\Entities\OmProduto';

    public function __construct()
    {
        parent::__construct(self::ENTITY_NAME);
    }

    /**
     * @param $productId
     * @return array[]
     * @throws Exception
     */
    public function findOrganizationProduct($productId, $filterDtValidade = 'S'): array
    {
        $dtValidadeFilter = "";
        if($filterDtValidade == 'S') {
            $dtValidadeFilter = "AND (TRUNC(OE.DTVALIDADE) >= TRUNC(SYSDATE) OR OE.DTVALIDADE IS NULL)";
        }
        $query = "
                SELECT DISTINCT PO.NRORG_ID AS NRORG
                FROM OM_PRODUTO_ORG_ELEMENTO OE
                JOIN OM_PRODUTO_ORG PO ON PO.ID = OE.NRPRODUTO_ORG_ID
                JOIN OM_PRODUTO_ELEMENTO PE ON PE.ID = OE.NRPRODUTO_ELEMENTO_ID
                JOIN OM_PRODUTO OP ON OP.ID = PO.NRPRODUTO_ID
                WHERE OP.NREXTERNAL_PRODUCT_ID = :PRODUCT_ID
                $dtValidadeFilter
        ";

        $params = array(
            'PRODUCT_ID' => $productId
        );

        return $this->entityManager->getConnection()->fetchAllAssociative($query, $params);
    }
}
