<?php


namespace OrganizationsManagement\Api\OrganizationProduct\Services;


use Doctrine\DBAL\Exception;
use OrganizationsManagement\Api\OrganizationProduct\Repositories\OrganizationProduct as OrganizationProductRepository;

class OrganizationProduct
{
    /**
     * @var OrganizationProductRepository
     */
    private $organizationProductRepository;

    public function __construct(OrganizationProductRepository $organizationProductRepository)
    {
        $this-> organizationProductRepository = $organizationProductRepository;
    }

    /**
     * @param $organizationId
     * @param $productId
     * @return array[]
     * @throws Exception
     */
    public function findOrganizationProduct($productId, $filterDtValidade = 'S'): array
    {
        $ids = array();
        $organizations = $this->organizationProductRepository->findOrganizationProduct($productId, $filterDtValidade);
        foreach ($organizations as $row) {
            $ids[] = $row['NRORG'];
        }
        return $ids;
    }
}
