<?php
namespace OrganizationsManagement\Factory;
use Teknisa\Model\Teknisa\Entities\OmProdutoOrg as OrganizationProductEntity;
use Teknisa\Model\Teknisa\Entities\OmProdutoOrgColetor as EntidadeOmProdutoOrgColetor;
use Teknisa\Model\Util\NovoCodigo;
use OrganizationsManagement\Util\InstanceProvider;

class ProdutoOrg {
    
    public function save(OrganizationProductEntity $organizationProduct = null, $nrOrgId, $nrProdutoId, $currentUserId, $currentOrganizationId, $dateNow, $idAtivo = 'S', $idProdutoSaas = 'S'){
        if(!$organizationProduct) {
            $organizationProduct = new OrganizationProductEntity();
            $novoCodigo = NovoCodigo::geraCodigo($currentOrganizationId, 'OM_PRODUTO_ORG', 1, 10, true, false);
            $organizationProduct->setId($novoCodigo);
            $organizationProduct->setNrorgId($nrOrgId);
            $organizationProduct->setDtinclusao($dateNow);
            $organizationProduct->setNrprodutoId($nrProdutoId);
            $organizationProduct->setNrorg($currentOrganizationId);
            $organizationProduct->setCdoperinclusao($currentUserId);
            $organizationProduct->setNrorginclusao($currentOrganizationId);
        }
        $organizationProduct->setIdprodutosaas($idProdutoSaas);
        $organizationProduct->setIdativo($idAtivo);
        $organizationProduct->setDtultatu($dateNow);
        $organizationProduct->setCdoperultatu($currentUserId);
        $organizationProduct->setNrorgultatu($currentOrganizationId);

        return $organizationProduct;
    }

    public function saveProductOrgCollector(EntidadeOmProdutoOrgColetor $collector = null, $currentOrgId, $codOperador, $dateNow,
                         $idColetor, $dsStringConexao, $idUtWallet, $dsUsuarioBanco, $dsSenhaBanco, $idativo, $nrProdutoOrgId, $idTpBanco)
    {
        if ($collector === null) {
            $novoCodigo = NovoCodigo::geraCodigo($currentOrgId, "OM_PRODUTO_ORG_COLETOR", 1, 10, false, false);
            $collector = new EntidadeOmProdutoOrgColetor();
            $collector->setId($novoCodigo);
            $collector->setCdoperinclusao($codOperador);
            $collector->setNrorginclusao($currentOrgId);
            $collector->setDtinclusao($dateNow);
            $collector->setNrorg($currentOrgId);
        }
        
        $collector->setCdoperultatu($codOperador);
        $collector->setNrorgultatu($currentOrgId);
        $collector->setDtultatu($dateNow);
        
        $collector->setIdativo($idativo);
        $collector->setNrprodutoOrgId($nrProdutoOrgId);
        $collector->setIdcoletor($idColetor);
        $collector->setDsstringconexao($dsStringConexao);
        $collector->setIdutwallet($idUtWallet);
        $collector->setDsusuariobanco($dsUsuarioBanco);
        $collector->setDssenhabanco($dsSenhaBanco);
        $collector->setIdtpbanco($idTpBanco);
        
        return $collector;
    }

    public function updateElementosManuais($contractCode, $dsobservacao, $codOperador, $expirationDate) {

        $query = "UPDATE OM_PRODUTO_ORG_ELEMENTO
                    SET DSOBSERVACAO = DSOBSERVACAO||:DSOBSERVACAO,
                        DTULTATU     = SYSDATE,
                        CDOPERULTATU = :CDOPERULTATU,
                        DTVALIDADE =   TO_DATE(:DTVALIDADE, 'DD/MM/YYYY')
                  WHERE ID IN (
                    SELECT OE.ID FROM OM_PRODUTO_ELEMENTO PE
                    LEFT JOIN OM_PRODUTO_ORG_ELEMENTO OE ON OE.NRPRODUTO_ELEMENTO_ID = PE.ID
                    LEFT JOIN OM_PROD_ORG_ELEMENTO_CONTRATO PC ON PC.NRPRODUTO_ORG_ELEMENTO_ID = OE.ID
                    WHERE PC.IDALTERMANUAL = 'S' AND PC.NRSEQCONTRATO = :NRSEQCONTRATO
                  )";

        $params = array(
            'NRSEQCONTRATO' => $contractCode,
            'DSOBSERVACAO'  => $dsobservacao,
            'CDOPERULTATU'  => $codOperador,
            'DTVALIDADE'    => $expirationDate
        );
        
        InstanceProvider::getEntityManager()->getConnection()->executeQuery($query, $params);
    }
}
