# API Organizações por Produto
Retorna ids das organizações do produto informado.
## Produto requisitado:

| Nome                     | url            | uri                                      |
|--------------------------|----------------|------------------------------------------|
| Organizations Management | om.teknisa.com | https://om.teknisa.com/backend/index.php |

## Verbos HTTPs permitidos:
GET

## Informações de acesso:

API de consulta com rota(s) pública(s)
### Rotas

```
/api/organization_product
```
Método `GET`

**Parâmetros**

| Parâmetro         | Tipo         | Descrição                                 |
|-------------------|--------------|-------------------------------------------|
| PRODUCT_ID        | int - String | Id do produto (Tabela PRODUCT)            |
| FILTER_DTVALIDADE | String       | Filtrar data de validade (Default 'S')    |

###### Exemplo de uso em `php`:

```php
<?php

$url = "https://om.teknisa.com/backend/index.php/api/organization_product";
$header[] = 'Content-Type: application/json';
$dataArray = [ 'PRODUCT_ID' => 161 ];
// Caso deseje que retorne os ids das organizações com todos os elementos inadimplentes:
// $dataArray = [ 'PRODUCT_ID' => 161, 'FILTER_DTVALIDADE' => 'N' ];
$data = http_build_query($dataArray);
$getUrl = $url."?".$data;

$curl = curl_init();

curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
curl_setopt($curl, CURLOPT_URL, $getUrl);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

$output = curl_exec($curl);
$output = json_decode($output, true);
$error = curl_error($curl);

if ($error) {
    var_dump($error);
} else {
    var_dump($output);
}

curl_close($curl);
```

### Retorno

```php
array(1) {
  ["dataset"]=>
  array(1) {
    ["data"]=>
    array(3) {
      [0]=>
      string(3) "20"
    }
  }
}
```
